#include <stdio.h>
#include <gmp.h>
#include <mpfr.h>

/*
 * To compile:
 * gcc -O3 test_mpfr.c -o test_mpfr -lmpfr
 *
 */

int main (void)
{
  unsigned int i;
  mpfr_t s, t, u;

  // float t = 1.0;
  mpfr_init2 (t, 200);
  mpfr_set_d (t, 1.0, MPFR_RNDD);
  // float s = 1.0;
  mpfr_init2 (s, 200);
  mpfr_set_d (s, 1.0, MPFR_RNDD);
  // float u;
  mpfr_init2 (u, 200);

  for (i = 1; i <= 100; i++)
    {
      // t = t * i;
      mpfr_mul_ui (t, t, i, MPFR_RNDU);
      // u = 1.0;
      mpfr_set_d (u, 1.0, MPFR_RNDD);
      // u = u / t;
      mpfr_div (u, u, t, MPFR_RNDD);
      // s = s + u;
      mpfr_add (s, s, u, MPFR_RNDD);
    }

  // Print results
  printf ("Sum is ");
  mpfr_out_str (stdout, 10, 0, s, MPFR_RNDD);
  putchar ('\n');

  // Cleanup
  mpfr_clear (s);
  mpfr_clear (t);
  mpfr_clear (u);
  mpfr_free_cache ();

  return 0;
}
